function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React from 'react';
import { Dropdown, Menu, Button as AntdButton } from 'antd';
import { DownOutlined } from '@ant-design/icons';
import classNames from 'classnames';
import Button from "./button";
import "./index.less";
export function ButtonList(_ref) {
  var dataSource = _ref.dataSource,
    maxItems = _ref.maxItems;
  var newDataSource = dataSource.slice() || [];
  newDataSource = newDataSource.filter(function (item) {
    var _item$buttonProps;
    return !(item !== null && item !== void 0 && (_item$buttonProps = item.buttonProps) !== null && _item$buttonProps !== void 0 && _item$buttonProps.disabled);
  });
  var firstPart = newDataSource;
  var secondPart = [];
  if (newDataSource.length - maxItems > 0) {
    firstPart = newDataSource.slice(0, maxItems - 1);
    secondPart = newDataSource.slice(maxItems - 1);
  }
  var result = firstPart.map(function (item, index) {
    var _item$buttonProps2;
    if ((_item$buttonProps2 = item.buttonProps) !== null && _item$buttonProps2 !== void 0 && _item$buttonProps2.disabled) {
      return null;
    }
    return /*#__PURE__*/React.createElement(Button, _extends({
      key: index
    }, item, {
      buttonProps: _objectSpread(_objectSpread({}, item.buttonProps || {}), {}, {
        className: classNames(item.className, 'cfListButton')
      })
    }));
  });
  if (secondPart.length) {
    var menu = /*#__PURE__*/React.createElement(Menu, null, secondPart.map(function (item, index) {
      return /*#__PURE__*/React.createElement(Menu.Item, {
        key: index
      }, /*#__PURE__*/React.createElement(Button, _extends({
        key: index
      }, item, {
        buttonProps: _objectSpread(_objectSpread({}, item.buttonProps || {}), {}, {
          type: 'link'
        })
      })));
    }));
    result = [].concat(_toConsumableArray(result), [/*#__PURE__*/React.createElement(Dropdown, {
      key: "button-list-more-dropdown",
      overlay: menu
    }, /*#__PURE__*/React.createElement(AntdButton, {
      className: "cfListButton",
      type: "link"
    }, "\u66F4\u591A ", /*#__PURE__*/React.createElement(DownOutlined, null)))]);
  }
  return /*#__PURE__*/React.createElement("div", {
    className: "buttonList"
  }, result);
}
export default Button;